/*
  Library for TSIC digital Temperature Sensor Type 206/306 and may more.
  using ZACwire Communication Protocol for the TSic
  Manufatorer:		IST AG, Hygrosens, ZMD
  Original Code:	http://www.mikrocontroller.net/topic/82087
  rewritten by:		Rolf W.
  Date:				2010.03.06
  Temperature-sensor uses 2 Pins, one for VCC and the second for Signal (= ZACwire Protocol).
  With call of the Function ".....getTSicTemp();" the Senor will get power measure and will be turned OFF.
  In that case it uses only energy while measuring. There is another method with Interrupts, measuring
  at an constant rate, which is not implemented jet.
*/
#ifndef tsic_H
#define tsic_H
#include <inttypes.h>
#include "Main.h"

/******************************************************************************/
// TSIC Signal-Pin
#define TSIC_PORT             PORTA  // Port to use
#define TSIC_PIN              PINA
#define TSIC_PORT_DDR         DDRA
#define TSIC_SIGNAL_PIN       (1<<PIN1)

// TSIC VCC
#define TSIC_PORT_Power       PORTE
#define TSIC_PORT_DDR_Power   DDRE
#define TSCI_POWER_PIN        (1<<PIN6)
/******************************************************************************/

#define TSIC_ON()             TSIC_PORT_Power |=  TSCI_POWER_PIN		// Power up the TSIC-Sensor
#define TSIC_OFF()            TSIC_PORT_Power &= ~TSCI_POWER_PIN		// Power down the TSIC-Sensor
#define TSIC_SIGNAL_HIGH         TSIC_PIN & TSIC_SIGNAL_PIN				// High Signal of the TSIC-Sensor
#define TSIC_SIGNAL_LOW       !( TSIC_PIN & TSIC_SIGNAL_PIN)			//  Low Signal of the TSIC-Sensor

void TSIC_INIT(void);
uint8_t getTSicTemp (uint16_t *temp_value16);

#endif
